<?php
/**
* Archivo para crear controles
*
* @package command.php
* @copyright 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @review 1
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 14-abril-2008
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/

/**
* Ejemplo de uso
* $commad1=new command();
* $commad1->clicar("borraCita(\''.$id_cita.'\',\''.$dia.'\',\''.$mes.'\',\''.$anyo.'\')");
* $commad1->titulo("Hola, hola");
* $commad1->alto(50); //puede ser también en porcentaje
* $commad1->imagen("../preadmin/imgs/borra_peq.png"); //Ruta completa
* $commad1->alineacion("RIGHT"); //valores permitidos RIGHT, LEFT
* $commad1->show();
*/

class command
{
	private $control='<a href="#" id="" onclick="" title=""><img class="" ALIGN="" WIDTH=""  HEIGHT="" border="" src="" alt=""/></a>';

	private function reemplazar($cadena,$evento)
		{
		return str_replace($cadena,$evento,($this-> control));
		}

	function url($nombre)
		{
		$nombre1='href="'.$nombre.'"';
		$this->control=$this->reemplazar('href="#"',$nombre1);
		}

	function texto($nombre)
		{
		$nombre1='">'.$nombre.'<img';
		$this->control=$this->reemplazar('"><img',$nombre1);
		}

	function clicar($evento)
		{
		$evento1='onclick="'.$evento.'"';
		$this->control=$this->reemplazar('onclick=""',$evento1);
		}

	function titulo($nombre)
		{
		$nombre1='title="'.$nombre.'"';
		$this->control=$this->reemplazar('title=""',$nombre1);
		}

	function clase($nombre)
		{
		$nombre1='class="'.$nombre.'"';
		$this->control=$this->reemplazar('class=""',$nombre1);
		}

	function imagen($nombre)
		{
		$nombre1='src="'.$nombre.'"';
		$this->control=$this->reemplazar('src=""',$nombre1);
		}

	function titulo_alt($nombre)
		{
		$nombre1='alt="'.$nombre.'"';
		$this->control=$this->reemplazar('alt=""',$nombre1);
		}

	function borde($nombre)
		{
		$nombre1='border="'.$nombre.'"';
		$this->control=$this->reemplazar('border=""',$nombre1);
		}

	function ancho($nombre)
		{
		$nombre1='WIDTH="'.$nombre.'"';
		$this->control=$this->reemplazar('WIDTH=""',$nombre1);
		}
	
	function alto($nombre)
		{
		$nombre1='HEIGHT="'.$nombre.'"';
		$this->control=$this->reemplazar('HEIGHT=""',$nombre1);
		}

	function alineacion($nombre)
		{
		$nombre1='ALIGN="'.$nombre.'"';
		$this->control=$this->reemplazar('ALIGN=""',$nombre1);
		}

	function id($nombre)
		{
		$nombre1='id="'.$nombre.'"';
		$this->control=$this->reemplazar('id=""',$nombre1);
		}

	function show()
			{
			echo ($this-> control);
			}		
}




class input
{
	private $control='<input class="" id="" type="" value="" maxlength="" size="" name="" />';

	private function reemplazar($cadena,$evento)
		{
		return str_replace($cadena,$evento,($this-> control));
		}

	function tipo($nombre)
		{
		$nombre1='type='.$nombre.'';
		$this->control=$this->reemplazar('type=""',$nombre1);
		}

	function id($nombre)
		{
		$nombre1='id='.$nombre.'';
		$this->control=$this->reemplazar('id=""',$nombre1);
		}

	
	function valor($nombre)
		{
		$nombre1='value="'.$nombre.'"';
		$this->control=$this->reemplazar('value=""',$nombre1);
		}

	function nombre($nombre)
		{
		$nombre1='name="'.$nombre.'"';
		$this->control=$this->reemplazar('name=""',$nombre1);
		}

	function maxlength($nombre)
		{
		$nombre1='maxlength="'.$nombre.'"';
		$this->control=$this->reemplazar('maxlength=""',$nombre1);
		}

	function size($nombre)
		{
		$nombre1='size="'.$nombre.'"';
		$this->control=$this->reemplazar('size=""',$nombre1);
		}

	function clase($nombre)
		{
		$nombre1='class="'.$nombre.'"';
		$this->control=$this->reemplazar('class=""',$nombre1);
		}


	function show()
			{
			echo ($this-> control);
			}	
}

class combo
{

	private $control='<select name="" id="" style="width:">';

	private function reemplazar($cadena,$evento)
		{
		return str_replace($cadena,$evento,($this-> control));
		}

	function combo($nombre,$matriz,$select)
		{
		$this->nombre($nombre);
		$this->lista($matriz,$select);
		}

	private function nombre($nombre)
		{
		$nombre1='name="'.$nombre.'"';
		$this->control=$this->reemplazar('name=""',$nombre1);
		}

	function id($nombre)
		{
		$nombre1='id="'.$nombre.'"';
		$this->control=$this->reemplazar('id=""',$nombre1);
		}

	function width($nombre)
		{
		$nombre1='style="width:'.$nombre.'"';
		$this->control=$this->reemplazar('style="width:"',$nombre1);
		}


	private function lista($matriz,$select)
		{
		foreach($matriz as $dato)
			{
				if ($dato[0]!=$select)
				{
				$this->control=$this->control.'<option value='.$dato[0].'>'.$dato[1].'</option>';
				}else{
				$this->control=$this->control.'<option value='.$dato[0].' selected>'.$dato[1].'</option>';
				}	
			}
			$this->control=$this->control.'</select>';
		}
	function show()
			{
			echo ($this-> control);
			}	

}
