<?php
/**
* Archivo modelo de mensajes
*
* @package m_mensajes.php
* @copyright 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 20-noviembre-2007 
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/
/**
* Incluye el fichero de clases para postgres
*
*/
include_once('../modelo/postgres.php');



/**
* Funcion para obtener la fecha de los mensajes nuevos de un usuario
*
* Con esta función se obtienen las fechas de todos los mensajes nuevos (borradores no) para un usuario 
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios

* @return Un array con los valores de las fechas de los mensajes nuevos de un usuario
*/
function mensajes_nuevos($usuario)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select fecha from mensajes where (destinatario='$usuario' and lectura='0' and borrador='0')");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion[0]['fecha'];
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$conexion,$result);
}


/**
* Funcion para obtener los mensajes nuevos de un usuario
*
* Con esta función se obtienen todos los mensajes nuevos (borradores no) para un usuario 
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios

* @return Un array con los mensajes nuevos de un usuario
*/
function mensajesrec($usuario)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from mensajes where destinatario='$usuario' and borrador='0' and ocultorec='0' or destinatario='-1' and borrador='0' and ocultorec='0' order by fecha desc");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}



/**
* Funcion para obtener la filiacion de un usuario
*
* Con esta función se obtienen los datos de un usuario 
* @param $remitente es de tipo integer y se corresponde con primary key de la tabla personas

* @return Un array con los datos del usuario
*/
function datos_personales($remitente)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select firstname,lastname from usu_pers where id_user='$remitente'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}

/**
* Funcion para obtener la filiacion de todos los usuario
*
* Con esta función se obtienen los datos de todos los usuarios 
* @param no tiene parametros de entrada

* @return Un array con los datos de todos los usuarios
*/
function usuarios()
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select id_user, username,firstname,lastname from usu_pers order by firstname");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}



/**
* Funcion para borrar un mensaje recibido de la carpeta de recibidos
*
* Con esta función se borra aparentemente un mensaje concreto. En realidad solo se modifica una bandera
* @param $id es de tipo integer y se corresponde con primary key de la tabla mensajes
*
* @return cero en caso de error
*/
function borrarmensajerec($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query("update mensajes set ocultorec='1' where id='$id'");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}

/**
* Funcion para borrar un mensaje enviado de la carpeta de enviados
*
* Con esta función se borra aparentemente un mensaje concreto. En realidad solo se modifica una bandera
* @param $id es de tipo integer y se corresponde con primary key de la tabla mensajes
*
* @return cero en caso de error
*/
function borrarmensajeenv($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query("update mensajes set ocultoenv='1' where id='$id'");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}



/**
* Funcion para borrar un mensaje enviado de la carpeta de borradores
*
* Con esta función se borra aparentemente un mensaje concreto. En realidad solo se modifica una bandera
* @param $id es de tipo integer y se corresponde con primary key de la tabla mensajes
*
* @return cero en caso de error
*/
function borrarmensajeborrador($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query("delete from mensajes where id='$id'");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}


/**
* Funcion para obtener los mensajes enviados por un usuario y que no ha borrado de la carpeta de enviados
*
* Con esta función se obtienen todos los mensajes enviados por un usuario y que no esten borrados de la carpeta de enviados
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios

* @return Un array con los mensajes enviados por el usuario
*/
function mensajesenv($usuario)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from mensajes where remitente='$usuario' and ocultoenv= '0' order by fecha desc");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}


/**
* Funcion para marcar un mensaje como leido
*
* Con esta función se marca un mensaje como leido
* @param $ides de tipo integer y se corresponde con primary key de la tabla mensajes

* @return 0 si ha producido un error
*/
function marcaleido($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query("update mensajes set lectura='1' where id='$id'");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}



/**
* Funcion para leer un mensaje concreto
*
* Con esta función se obtienen los datos correspondientes a un mensaje concreto
* @param $id de tipo integer y se corresponde con primary key de la tabla mensajes

* @return Un array con los campos del resgistro 
*/
function leemensaje($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from mensajes where id='$id'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}


/**
* Funcion para obtener los mensajes de un usuario que esten en la carpeta de borradores
*
* Con esta función se obtienen los mensajes de un usuario que esten en la carpeta de borradores
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios

* @return Un array con los mensajes enviados por el usuario a la carpeta de borradores
*/
function mensajes_borrador($usuario)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from mensajes where remitente='$usuario' and borrador='1' order by fecha desc");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}


/**
* Funcion para actualizar un mensaje de un usuario que este en la carpeta de borradores
*
* Con esta función se actualiza un mensaje de un usuario que este en la carpeta de borradores
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios
* @param $_POST es un array con los datos del mensaje

* @return cero si se produce un error
*/
function mensajes_borrador_edita($_POST,$usuario)
{
$id_borr=$_POST['idb'];
$asunto = $_POST['asunto'];
$destino = $_POST['destin_doc'];
$texto = $_POST['texto'];
$mensaje_pre = str_replace("[igual]","=",$texto);
$mensaje = str_replace("~inte~","?",$mensaje_pre);
$datetime = date('Y-m-d H:i:s');

$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("update mensajes set destinatario='$destino',asunto='$asunto',mensaje='$mensaje',tipo='$tipo',fecha='$datetime' where id='$id_borr'");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}

/**
* Funcion para agregar un mensaje de un usuario  en la carpeta de borradores
*
* Con esta función se agrega un mensaje de un usuario en la carpeta de borradores
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios
* @param $_POST es un array con los datos del mensaje

* @return cero si se produce un error
*/
function mensajes_borrador_nuevo($_POST,$usuario)
{
$asunto = $_POST['asunto'];
$destino = $_POST['destin_doc'];
$texto = $_POST['texto'];
$mensaje_pre = str_replace("[igual]","=",$texto);
$mensaje = str_replace("~inte~","?",$mensaje_pre);
$datetime = date('Y-m-d H:i:s');

$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("insert into mensajes(remitente,destinatario,asunto,mensaje,lectura,borrador,fecha,tipo,ocultorec,ocultoenv) values('$usuario','$destino','$asunto','$mensaje','0','1','$datetime','$tipo','0','1')");
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}



/**
* Funcion para enviar un mensaje de un usuario  desde la carpeta de borradores
*
* Con esta función se envia un mensaje de un usuario desde la carpeta de borradores
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla usuarios
* @param $_POST es un array con los datos del mensaje

* @return cero si se produce un error
*/
function mensajes_borrador_envia($_POST,$usuario)
{

$asunto = $_POST['asunto'];
$destino = $_POST['destin_doc'];
$texto = $_POST['texto'];
$mensaje_pre = str_replace("[igual]","=",$texto);
$mensaje = str_replace("~inte~","?",$mensaje_pre);
$datetime = date('Y-m-d H:i:s');

$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("insert into mensajes(remitente,destinatario,asunto,mensaje,lectura,borrador,fecha,tipo,ocultorec,ocultoenv) values('$usuario','$destino','$asunto','$mensaje','0','0','$datetime','$tipo','0','0')");
	if($_POST['idb'])
		{
		$id_borr=$_POST['idb'];
		$conexion=$conecto->query ("delete from mensajes where id='$id_borr'");
		}
	if($conexion!="")//nos aseguramos que hay coincidencia
		{
			$result = $conexion;
		}else{
			$result = '0';
		}
		$conecto->commit();
		return $result;
		}
unset ($conecto,$conexion,$result);
}
?>
